<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
<xsl:output method="html" indent="no"/>

<!-- Process the root node to begin the transformation -->
<xsl:template match="/">
<html>
<head>
<title>Slideshow</title>
<meta http-equiv="Content-type" content="text/html; charset=utf-8"/>
<link rel="stylesheet" type="text/css" href="/common/common.css"/>
<script type="text/javascript" src="http://maps.google.com/maps/api/js?sensor=false"></script>
</head>
<body>

<table class="stdtable" background="/common/head.jpg">
<tbody>
<tr height="44">
<td width="30"></td>
<td class="header"><a href="/dam"><xsl:value-of select="View/Owner"/></a></td>
<td>&#160;</td>
<td class="header" align="center" width="90"><a href="/dam?c=c">Compare</a></td>
<td class="header" align="center" width="90"><a href="/dam?c=r">Return</a></td>
<td width="30"></td>
</tr>
</tbody></table>

<table class="stdtable" align="center">
<tbody>
<tr height="44">
<td id="cap1" nowrap="" align="center" width="14%" class="tabp" onmouseover="ShowExif(this);" onmouseout="HideExif();"><img src="/common/info.gif" width="12" height="12" border="0" alt=""/> EXIF</td>
<td id="cap2" nowrap="" align="center" width="14%" class="tabp">FPV</td>
<td id="cap3" nowrap="" align="center" width="14%" class="tabp" onclick="DoPrevious();"><img src="/common/arlt.gif" border="0" alt=""/></td>
<td id="cap4" nowrap="" align="center" width="14%">  </td>
<td id="cap5" nowrap="" align="center" width="14%" class="tabp" onclick="DoNext();"><img src="/common/arrt.gif" border="0" alt=""/></td>
<td id="cap6" nowrap="" align="center" width="14%" class="tabp"><img src="/common/disk.png" width="12" height="12" border="0" alt=""/> Download</td>
<td id="cap7" nowrap="" align="center" width="14%" class="tabp" onClick="ToggleMap();"><img src="/common/info.gif" width="12" height="12" border="0" alt=""/> GPS</td>
</tr>
</tbody></table>

<div id="frame1" align="center" style="width:100%; visibility:visible; position:absolute; top:100; left:000;">
<img class="picborder" id="image1" src="/common/icon-minus.gif" alt="" galleryimg="no"/>
</div>

<div id="frame2" align="center" style="width:100%; visibility:visible; position:absolute; top:100; left:000;">
<img class="picborder" id="image2" src="/common/icon-minus.gif" alt="" galleryimg="no"/>
</div>

<div id="frame3" align="center" style="width:100%; visibility:visible; position:absolute; top:100; left:000;">
<img class="picborder" id="image3" src="/common/icon-minus.gif" alt="" galleryimg="no"/>
</div>

<div id="footer" style="visibility:visible; position:absolute; left:0;">
<table class="stdtable" align="center">
<tbody><tr>
<td id="cap8" nowrap="" align="center" width="33%"></td>
<td id="cap9" nowrap="" align="center" width="33%"></td>
<td id="cap10" nowrap="" align="center" width="33%"></td>
</tr>
</tbody></table>
</div>

<div id="exif" style="visibility:hidden; position:absolute; top:100; width:400px">
<table width="100%" cellpadding="2" cellspacing="0" bgcolor="#000000" class="picborder">
<tbody><tr><td align="center" colspan="5"><b>Exif Data</b></td></tr>
<tr><td align="center" colspan="5"></td></tr>
<tr> <td></td><td valign="top">DateTimeOrig:</td><td width="20"> </td><td id="c0"></td><td> </td></tr>
<tr> <td></td><td valign="top">Ranking:</td><td> </td><td id="c1"></td><td> </td></tr>
<tr> <td></td><td valign="top">Headline:</td><td> </td><td id="c2"></td><td> </td></tr>
<tr> <td></td><td valign="top">Keywords:</td><td> </td><td id="c3"></td><td> </td></tr>
<tr> <td></td><td valign="top">City:</td><td> </td><td id="c4"></td><td> </td></tr>
<tr> <td></td><td valign="top">State:</td><td> </td><td id="c5"></td><td> </td></tr>
<tr> <td></td><td valign="top">Country:</td><td> </td><td id="c6"></td><td> </td></tr>
<tr> <td></td><td valign="top">Copyright:</td><td> </td><td id="c7"></td><td> </td></tr>
<tr> <td></td><td valign="top">Camera:</td><td> </td><td id="c8"></td><td> </td></tr>
<tr> <td></td><td valign="top">Lens:</td><td> </td><td id="c9"></td><td> </td></tr>
<tr> <td></td><td valign="top">ISO:</td><td> </td><td id="c10"></td><td> </td></tr>
<tr> <td></td><td valign="top">ShutterSpeed:</td><td> </td><td id="c11"></td><td> </td></tr>
<tr> <td></td><td valign="top">Aperture:</td><td> </td><td id="c12"></td><td> </td></tr>
<tr> <td></td><td valign="top">FocalLength:</td><td> </td><td id="c13"></td><td> </td></tr>
<tr> <td></td><td valign="top">VR:</td><td> </td><td id="c14"></td><td> </td></tr>
<tr> <td></td><td valign="top">ImageSize:</td><td> </td><td id="c15"></td><td> </td></tr>
</tbody></table>
</div>

<div id="map_canvas" class="picborder" style="visibility:hidden; position:absolute; top:100; width:600px; height:700px;"></div>

<script type="text/javascript" language="JavaScript">
var imgList = [];
var myframes = [];
var myimages = [];
var stat = [];
var cells = [];
myframes[0] = document.getElementById("frame1");
myframes[1] = document.getElementById("frame2");
myframes[2] = document.getElementById("frame3");
myimages[0] = document.getElementById("image1");
myimages[1] = document.getElementById("image2");
myimages[2] = document.getElementById("image3");
var idFooter = document.getElementById("footer");
var idCaption2 = document.getElementById("cap2");
var idCaption4 = document.getElementById("cap4");
var idCaption6 = document.getElementById("cap6");
var idCaption7 = document.getElementById("cap7");
var idCaption8 = document.getElementById("cap8");
var idCaption9 = document.getElementById("cap9");
var idCaption10 = document.getElementById("cap10");
var idMapframe = document.getElementById("map_canvas");
var idExif = document.getElementById("exif");
for (i = 0; i &lt; 16; i++) {
  cells[i] = document.getElementById("c"+i);
}

var Files = new Array();
var Exifs = new Array();
var ScreenHeight = 0;
var ScreenWidth = 0;
var CurrentImage = 0;
var NextImage = 0;
var CurrentFrame = 0;
var DrawFrame = 0;
var map = 0;
var marker = 0;
var MaxHeight = 0;
var MaxWidth = 0;

var First = <xsl:value-of select="View/First"/>;
var numimgs = <xsl:value-of select="View/Number"/>;
<xsl:apply-templates select="View/Records"/>

window.onresize = doResize;
doResize();
CurrentImage=First;
imgList[CurrentImage] = new Image;
imgList[CurrentImage].onload = loaded1;
imgList[CurrentImage].src = "/image?Path=" + encodeURIComponent(Files[CurrentImage]) + "&amp;X=" + MaxWidth + "&amp;Y=" + MaxHeight;
NextImage = CurrentImage;
DrawFrame = 1;
DrawImage();
CurrentFrame = 1;
ShowFrame();
DoCaptions();
setTimeout("DoInit2();", 400);

function DoInit2() {
  CurrentImage++;
  if (CurrentImage &gt;= numimgs) {CurrentImage = 0; }
  imgList[CurrentImage] = new Image;
  imgList[CurrentImage].onload = loaded2;
  imgList[CurrentImage].src = "/image?Path=" + encodeURIComponent(Files[CurrentImage]) + "&amp;X=" + MaxWidth + "&amp;Y=" + MaxHeight;
  NextImage = CurrentImage;
  DrawFrame = 2;
  DrawImage();
  CurrentImage = First - 1;
  if (CurrentImage &lt; 0) {CurrentImage = numimgs - 1; }
  imgList[CurrentImage] = new Image;
  imgList[CurrentImage].onload = loaded0;
  imgList[CurrentImage].src = "/image?Path=" + encodeURIComponent(Files[CurrentImage]) + "&amp;X=" + MaxWidth + "&amp;Y=" + MaxHeight;
  NextImage = CurrentImage;
  CurrentImage = First;
  DrawFrame = 0;
  DrawImage();
  loadMap();
}

function HideExif() {
  idExif.style.visibility="hidden";
}

function ShowExif() {
  var pos = ScreenWidth/2 - 200;
  idExif.style.left = pos + "px";
  idExif.style.visibility="visible";
}

function DoNext() {
  CurrentImage++;
  if (CurrentImage &gt;= numimgs) {CurrentImage = 0; }
  CurrentFrame++;
  if (CurrentFrame &gt; 2) {CurrentFrame = 0;}
  setTimeout("DoNext2();", 1);
}

function DoNext2() {
  if (stat[CurrentFrame] == 2) {
    ShowFrame();
    DoCaptions();
    setTimeout("DoNext3();", 1);
  } else {
    setTimeout("DoNext2();", 20);
  }
}

function DoNext3() {
  NextImage = CurrentImage + 1;
  if (NextImage &gt;= numimgs) {NextImage = 0; }
  DrawFrame = CurrentFrame + 1;
  if (DrawFrame &gt; 2) {DrawFrame = 0;}
  if (! imgList[NextImage]) {
    stat[DrawFrame] = 1;
    imgList[NextImage] = new Image;
    if (DrawFrame == 0) imgList[NextImage].onload = loaded0;
    if (DrawFrame == 1) imgList[NextImage].onload = loaded1;
    if (DrawFrame == 2) imgList[NextImage].onload = loaded2;
    imgList[NextImage].src = "/image?Path=" + encodeURIComponent(Files[NextImage]) + "&amp;X=" + MaxWidth + "&amp;Y=" + MaxHeight;
  }
  DrawImage();
}

function DoPrevious() {
  CurrentImage--;
  if (CurrentImage &lt; 0) {CurrentImage = numimgs - 1; }
  CurrentFrame--;
  if (CurrentFrame &lt; 0) {CurrentFrame = 2;}
  setTimeout("DoPrevious2();", 1);
}

function DoPrevious2() {
  if (stat[CurrentFrame] == 2) {
    ShowFrame();
    DoCaptions();
    setTimeout("DoPrevious3();", 1);
  } else {
    setTimeout("DoPrevious2();", 20);
  }
}

function DoPrevious3() {
  NextImage = CurrentImage - 1;
  if (NextImage &lt; 0) {NextImage = numimgs - 1; }
  DrawFrame = CurrentFrame - 1;
  if (DrawFrame &lt; 0) {DrawFrame = 2;}
  if (! imgList[NextImage]) {
    stat[DrawFrame] = 1;
    imgList[NextImage] = new Image;
    if (DrawFrame == 0) imgList[NextImage].onload = loaded0;
    if (DrawFrame == 1) imgList[NextImage].onload = loaded1;
    if (DrawFrame == 2) imgList[NextImage].onload = loaded2;
    imgList[NextImage].src = "/image?Path=" + encodeURIComponent(Files[NextImage]) + "&amp;X=" + MaxWidth + "&amp;Y=" + MaxHeight;
  }
  DrawImage();
}

function loaded0 () {
  stat[0] = 2;
}
function loaded1 () {
  stat[1] = 2;
}
function loaded2 () {
  stat[2] = 2;
}

function ToggleMap() {
  if (idMapframe.style.visibility == "visible") {
    idMapframe.style.visibility = "hidden";	
    ShowFrame();
  } else {
    idMapframe.style.top = 100;
    idMapframe.style.left = (ScreenWidth/2 - 300) + "px";
    idMapframe.style.visibility = "visible";
    HideFrames();
    DoCaptions();
  }
}

function doResize() {
  GetScreenSize ();
  idFooter.style.top = (ScreenHeight - 40) + "px";
  idFooter.style.width = ScreenWidth + "px";
}

function DoCaptions () {
  var edat = new Array();
  edat = Exifs[CurrentImage].split("|");
  var myfil = Files[CurrentImage];
  myfil = myfil.replace(/\//g,"\\");
  idCaption2.innerHTML = '&lt;a href="fpv:' + myfil + '"&gt;&lt;img src="/common/fpv.jpg" border="0" width="12" height="12" alt="FastPictureViewer"/&gt; FPV&lt;/a&gt;';
  idCaption4.innerHTML = "[ " + (CurrentImage + 1) + "  of  " + numimgs + " ]";
  idCaption6.innerHTML = '&lt;a href="/image?Path=' + encodeURIComponent(Files[CurrentImage]) + '&amp;Attach=1"&gt;' + '&lt;img src="/common/disk.png" border="0" width="15" height="15" alt="Download"/&gt; Download&lt;/a&gt;';
  idCaption8.innerHTML = "Date: " + edat[14];
  idCaption9.innerHTML = Files[CurrentImage];
  idCaption10.innerHTML = edat[6] + ", " + edat[7] + ", " + edat[8];
  if (edat[39] &amp;&amp; edat[41]) {
    idCaption7.style.visibility = "visible";
  } else {
    idCaption7.style.visibility = "hidden";
  }
  if (idMapframe.style.visibility == "visible") {
    var point = new google.maps.LatLng(edat[39], edat[41]);
    if (edat[39] &amp;&amp; edat[41]) {
      map.setCenter(point);
      marker.setMap(null);
      marker = new google.maps.Marker({
        position: point, 
        map: map, 
        title: Files[CurrentImage]
      });
    }
  }
  cells[0].innerHTML = edat[14]; // date time
  var str = "";
  for (i=0; i &lt; edat[5]; i++) {
    str += "&#9733;";
  }
  cells[1].innerHTML = str;
  cells[1].style.color = 'yellow';
  cells[2].innerHTML = edat[3];
  cells[3].innerHTML = edat[4].replace (/,/g, "&lt;br/&gt;");  // keywords
  cells[4].innerHTML = edat[6];
  cells[5].innerHTML = edat[7];
  cells[6].innerHTML = edat[8];
  cells[7].innerHTML = edat[9];
  cells[8].innerHTML = edat[11];
  cells[9].innerHTML = edat[13];
  cells[10].innerHTML = edat[15];
  cells[11].innerHTML = edat[16];
  cells[12].innerHTML = edat[17];
  cells[13].innerHTML = edat[19];
  cells[14].innerHTML = edat[35];
  cells[15].innerHTML = edat[2];
}

function GetScreenSize () {
  if (document.all) {
    ScreenHeight = document.body.offsetHeight;
    ScreenWidth = document.body.offsetWidth;
  } else {
    ScreenHeight = window.innerHeight;
    ScreenWidth = window.innerWidth;
  }
  MaxHeight = ScreenHeight - (100+40+20);
  MaxWidth = ScreenWidth - (30);
}

function HideFrames() {
  var i = 0;
  for (i = 0; i &lt; 3; i++) {
    myframes[i].style.opacity = 0.0;
    myframes[i].style.filter="alpha(opacity=1)";
  }
}

function ShowFrame() {
  var i = 0;
  for (i = 0; i &lt; 3; i++) {
    if (i == CurrentFrame) {
      myframes[i].style.opacity = 1.0;
      myframes[i].style.filter="alpha(opacity=100)";
    } else {
      myframes[i].style.opacity = 0.01;
      myframes[i].style.filter="alpha(opacity=1)";
    }
  }
}

function DrawImage() {
  myimages[DrawFrame].src = imgList[NextImage].src;
}

function loadMap() {
  var script = document.createElement("script");
  script.type = "text/javascript";
  script.src = "http://maps.google.com/maps/api/js?sensor=false&amp;callback=initMap";
  document.body.appendChild(script);
}

function initMap() {
  var latlng = new google.maps.LatLng(37.8325, -122.4803);
  var myOptions = {
    zoom: 17,
    center: latlng,
    mapTypeId: google.maps.MapTypeId.HYBRID
  };
  map = new google.maps.Map(document.getElementById("map_canvas"), myOptions);
  marker = new google.maps.Marker({
    position: latlng, 
    map: map, 
    title: "Hello!"
  });  
}
</script>
</body>
</html>

</xsl:template>

<!-- Build Image Array -->
<xsl:template match="View/Records">
<xsl:for-each select="Rec">

Files[<xsl:value-of select="@Numb"/>]="<xsl:value-of select="@File"/>";
Exifs[<xsl:value-of select="@Numb"/>]='<xsl:call-template name="JS-escape"><xsl:with-param name="string" select="@Exif"/></xsl:call-template>';

</xsl:for-each>
</xsl:template>

<xsl:template name="JS-escape">
    <xsl:param name="string"/>		
    <xsl:variable name="CR" select="'&#xD;'"/>					
    <xsl:variable name="LF" select="'&#xA;'"/>
    <xsl:variable name="CRLF" select="concat($CR, $LF)"/>			
    <xsl:choose>
        <!-- double quote -->
        <xsl:when test="contains($string,&quot;'&quot;)">
            <xsl:call-template name="JS-escape">
                <xsl:with-param name="string" select="substring-before($string,&quot;'&quot;)"/>
            </xsl:call-template>\&apos;<xsl:call-template name="JS-escape">
                <xsl:with-param name="string" select="substring-after($string,&quot;'&quot;)"/>
            </xsl:call-template>
        </xsl:when>
        <!-- escape -->
        <xsl:when test="contains($string,'\')">
            <xsl:call-template name="JS-escape">
                <xsl:with-param name="string" select="substring-before($string,'\')"/>
            </xsl:call-template>\\<xsl:call-template name="JS-escape">
                <xsl:with-param name="string" select="substring-after($string,'\')"/>
            </xsl:call-template>
        </xsl:when>
        <xsl:otherwise>
            <xsl:value-of select="$string"/>
        </xsl:otherwise>
    </xsl:choose>
</xsl:template>

</xsl:stylesheet>
