<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
<xsl:output method="html" indent="no"/>

<!-- Process the root node to begin the transformation -->
<xsl:template match="/">
<html>
<head>
<title>Search <xsl:value-of select="Untagged/Owner"/></title>
<link rel="stylesheet" type="text/css" href="/common/common.css"/>
</head>
<body>
<table class="stdtable" background="/common/head.jpg">
<tr height="44">
<td width="30"></td>
<td class="header"><a href="http://malchsys/dam.cgi"><xsl:value-of select="Untagged/Owner"/></a></td>
<td>&#160;</td>
<td class="header" align="center" width="90"><a href="/dam">Browse</a></td>
<td class="header" align="center" width="90"><a href="/dam?c=s">Search</a></td>
<td width="30"></td>
</tr>
</table>

<table class="stdtable">
<tr height="12">
<td colspan="5"></td>
</tr>
<tr height="12">
<td width="5%"></td>
<td width="60%"></td>
<td width="10%"></td>
<td width="20%"></td>
<td width="5%"></td>
</tr>
<tr>
<td></td>
<td valign="top">

<table cellpadding="0" cellspacing="2" border="0">
<tr>
<td>&#160;</td>
<td></td>
<td></td>
</tr>
<tr>
<td class="header">Listing of Folders with Untagged Images</td>
<td></td>
<td></td>
</tr>
<tr>
<td>&#160;</td>
<td></td>
<td></td>
</tr>

<xsl:apply-templates select="Untagged/Records"/>

</table>
</td>
<td></td>
<td valign="top">

<table class="fancy">
<tr><td class="hot"><a href="/dam?c=b">Browse by Folder</a></td></tr>
<tr><td class="hot"><a href="/dam?c=s">Search Metadata</a></td></tr>
<tr><td class="cold" id="menu1"><a href="/dam?c=v">View Listed</a></td></tr>
<tr><td class="cold" id="menu2"><a href="/dam?c=c">Compare Listed</a></td></tr>
<tr><td class="cold" id="menu3"><a href="/dam?c=t">Tag Listed</a></td></tr>
<tr><td class="cold" id="menu4"><a href="/dam?c=u">Update Listed</a></td></tr>
</table>

</td>
<td></td>
</tr>
</table>
</body>
</html>
</xsl:template>

<!-- Build Folder Rows -->
<xsl:template match="Untagged/Records">
<xsl:for-each select="Rec">

<tr>
<td><a href="/dam?d={@Link}"><img src="/common/folder.gif" border="0"/><xsl:value-of select="@Folder"/></a></td>
<td></td>
<td><font size="-2"><xsl:value-of select="@Count"/> Files</font></td>
</tr>

</xsl:for-each>
</xsl:template>

</xsl:stylesheet>
